#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var roku_api_1 = require("../roku/roku-api");
var pretty_log_1 = require("../utils/pretty-log");
var argv = require('yargs/yargs')(process.argv.slice(2))
    .command('deploy', 'deploys a roku package', {
    path: {
        alias: 'p',
        demandOption: true,
        describe: 'path to roku project',
        normalize: true,
        type: 'string'
    },
}, function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var outputPath, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, (0, roku_api_1.deployProject)(argv.path, argv)];
            case 1:
                outputPath = _a.sent();
                (0, pretty_log_1.logSuccess)("Application was successfully deployed");
                return [3 /*break*/, 3];
            case 2:
                error_1 = _a.sent();
                (0, pretty_log_1.logError)(error_1.message);
                process.exit(1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); })
    .command('sign', 'signs a roku package', {
    name: {
        alias: 'n',
        describe: 'application package name (without .pkg)',
        default: 'app',
        type: 'string'
    },
    path: {
        alias: 'p',
        demandOption: true,
        describe: 'path to roku project',
        normalize: true,
        type: 'string'
    },
    signing: {
        alias: 's',
        demandOption: true,
        describe: 'path to signing properties folder',
        normalize: true,
        type: 'string'
    },
    output: {
        alias: 'o',
        describe: 'path to where the package should be saved',
        default: './',
        normalize: true,
        type: 'string'
    }
}, function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var outputPath, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, (0, roku_api_1.signPackage)(argv.path, argv.signing, argv.output, argv.name, argv)];
            case 1:
                outputPath = _a.sent();
                (0, pretty_log_1.logSuccess)("Package signed and stored at: ".concat(outputPath));
                return [3 /*break*/, 3];
            case 2:
                error_2 = _a.sent();
                (0, pretty_log_1.logError)(error_2.message);
                process.exit(1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); })
    .command('rekey', 'rekeys roku device', {
    signing: {
        alias: 's',
        demandOption: true,
        describe: 'path to signing properties folder',
        normalize: true,
        type: 'string'
    }
}, function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var error_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, (0, roku_api_1.executeDeviceRekey)(argv.signing, argv)];
            case 1:
                _a.sent();
                (0, pretty_log_1.logSuccess)('Device rekey applied.');
                return [3 /*break*/, 3];
            case 2:
                error_3 = _a.sent();
                (0, pretty_log_1.logError)(error_3.message);
                process.exit(1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); })
    .command('create-signing-credentials', 'creates new signing properties for an app (dev_id, password, package)', {
    name: {
        alias: 'n',
        describe: 'output package file name',
        default: 'app',
        type: 'string'
    },
    output: {
        alias: 'o',
        describe: 'path to where signing properties should be saved',
        default: './',
        normalize: true,
        type: 'string'
    }
}, function (argv) { return __awaiter(void 0, void 0, void 0, function () {
    var outputPath, error_4;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, (0, roku_api_1.createSigningCredentials)(argv.name, argv.output, argv)];
            case 1:
                outputPath = _a.sent();
                (0, pretty_log_1.logSuccess)("Signing credentials generated and stored at: ".concat(outputPath));
                return [3 /*break*/, 3];
            case 2:
                error_4 = _a.sent();
                (0, pretty_log_1.logError)(error_4.message);
                process.exit(1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); })
    .options({
    'device': {
        alias: 'd',
        describe: 'network address of the roku device. also could be set set through the environment variable: ROKU_DEVICE_ADDRESS',
        type: 'string'
    },
    'password': {
        alias: 'w',
        describe: 'password of the roku device. also could be set through the environment variable: ROKU_DEVICE_PASSWORD',
        type: 'string'
    },
    'username': {
        alias: 'u',
        describe: 'password of the roku device. also could be set through the environment variable: ROKU_DEVICE_PASSWORD',
        default: 'rokudev',
        type: 'string'
    }
})
    .demandCommand(1)
    .strict()
    .help()
    .argv;
