"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeDeviceRekey = exports.createSigningCredentials = exports.signPackage = exports.deployProject = void 0;
var path_1 = __importDefault(require("path"));
var fs_1 = __importDefault(require("fs"));
var rokuDeploy = __importStar(require("@adheus/roku-deploy"));
var roku_genkey_1 = require("../roku/roku-genkey");
var CREDENTIALS_FILENAME = 'credentials.json';
var PACKAGE_EXTENSION = '.pkg';
var RESOURCE_FOLDER_DIRECTORY = 'resources';
var SIGNING_PROJECT_PATH = 'signing-project';
function deployProject(projectPath, deviceProperties) {
    return __awaiter(this, void 0, void 0, function () {
        var finalDeviceProperties;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    finalDeviceProperties = getDeviceProperties(deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.device, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.password, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.username);
                    // Assert project path exists [AR]
                    assertPathExists(projectPath);
                    // Deploy project to device [AR]
                    return [4 /*yield*/, rokuDeploy.deploy(__assign(__assign({}, finalDeviceProperties), { project: "".concat(projectPath, "/bsconfig.json"), rootDir: projectPath, stagingFolderPath: './.roku-cli-staging', failOnCompileError: true }))];
                case 1:
                    // Deploy project to device [AR]
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.deployProject = deployProject;
function signPackage(projectPath, signingPath, outputPath, packageName, deviceProperties) {
    return __awaiter(this, void 0, void 0, function () {
        var finalDeviceProperties, signingProperties, signedPackagePath, generatedPackagePath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    finalDeviceProperties = getDeviceProperties(deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.device, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.password, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.username);
                    // Assert project path exists [AR]
                    assertPathExists(projectPath);
                    signingProperties = parseSigningProperties(signingPath);
                    signedPackagePath = path_1.default.resolve(signingProperties.packageFilePath);
                    return [4 /*yield*/, rokuDeploy.rekeyDevice(__assign(__assign({}, finalDeviceProperties), { signingPassword: signingProperties.credentials.password, rekeySignedPackage: signedPackagePath, devId: signingProperties.credentials.dev_id }))];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, rokuDeploy.deployAndSignPackage(__assign(__assign({}, finalDeviceProperties), { project: "".concat(projectPath, "/bsconfig.json"), rootDir: projectPath, signingPassword: signingProperties.credentials.password, devId: signingProperties.credentials.dev_id, outDir: outputPath, outFile: packageName, stagingFolderPath: './.roku-cli-staging', failOnCompileError: true }))];
                case 2:
                    generatedPackagePath = _a.sent();
                    return [2 /*return*/, generatedPackagePath];
            }
        });
    });
}
exports.signPackage = signPackage;
function createSigningCredentials(packageName, outputPath, deviceProperties) {
    return __awaiter(this, void 0, void 0, function () {
        var finalDeviceProperties, signingProperties, signingProjectPath, outputSigningPath, outputCredentialsPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    finalDeviceProperties = getDeviceProperties(deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.device, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.password, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.username);
                    return [4 /*yield*/, (0, roku_genkey_1.generateKey)(finalDeviceProperties.host)];
                case 1:
                    signingProperties = _a.sent();
                    signingProjectPath = getResourceAt(SIGNING_PROJECT_PATH);
                    // Assert project path exists [AR]
                    assertPathExists(signingProjectPath);
                    outputSigningPath = path_1.default.join(outputPath);
                    outputCredentialsPath = path_1.default.join(outputSigningPath, CREDENTIALS_FILENAME);
                    if (!fs_1.default.existsSync(outputSigningPath)) {
                        fs_1.default.mkdirSync(outputSigningPath, { recursive: true });
                    }
                    return [4 /*yield*/, rokuDeploy.deployAndSignPackage(__assign(__assign({}, finalDeviceProperties), { rootDir: signingProjectPath, signingPassword: signingProperties.password, devId: signingProperties.dev_id, outDir: outputPath, outFile: packageName }))];
                case 2:
                    _a.sent();
                    fs_1.default.writeFileSync(outputCredentialsPath, JSON.stringify(signingProperties));
                    return [2 /*return*/, outputSigningPath];
            }
        });
    });
}
exports.createSigningCredentials = createSigningCredentials;
function executeDeviceRekey(signingPath, deviceProperties) {
    return __awaiter(this, void 0, void 0, function () {
        var signingProperties, finalDeviceProperties;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    signingProperties = parseSigningProperties(signingPath);
                    finalDeviceProperties = getDeviceProperties(deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.device, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.password, deviceProperties === null || deviceProperties === void 0 ? void 0 : deviceProperties.username);
                    // Start rekey [AR]
                    return [4 /*yield*/, rokuDeploy.rekeyDevice(__assign(__assign({}, finalDeviceProperties), { signingPassword: signingProperties.credentials.password, rekeySignedPackage: path_1.default.resolve(signingProperties.packageFilePath), devId: signingProperties.credentials.dev_id }))];
                case 1:
                    // Start rekey [AR]
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.executeDeviceRekey = executeDeviceRekey;
function parseSigningProperties(signingPropertiesPath) {
    var files = fs_1.default.readdirSync(signingPropertiesPath);
    var packageFilename = files.find(function (filePath) { return path_1.default.extname(filePath) == PACKAGE_EXTENSION; });
    if (!packageFilename) {
        throw Error("Could not find package at path: ".concat(signingPropertiesPath));
    }
    var packageFilePath = path_1.default.join(signingPropertiesPath, packageFilename);
    var credentialsFilePath = path_1.default.join(signingPropertiesPath, CREDENTIALS_FILENAME);
    if (!path_1.default.resolve(credentialsFilePath)) {
        throw Error("Could not find credentials.json at path: ".concat(credentialsFilePath));
    }
    var credentialsData = fs_1.default.readFileSync(credentialsFilePath, 'utf-8');
    try {
        var credentials = JSON.parse(credentialsData);
        if (credentials.dev_id && credentials.password) {
            return { credentials: credentials, packageFilePath: packageFilePath };
        }
        else {
            throw Error("Missing required keys on credentials.json: dev_id, password");
        }
    }
    catch (error) {
        throw Error("Could not parse credentials file: ".concat(credentialsFilePath));
    }
}
function getResourceAt(resourcePath) {
    var resourcesFolderPath = path_1.default.resolve(path_1.default.join(__dirname, '..', '..', RESOURCE_FOLDER_DIRECTORY));
    return path_1.default.resolve(path_1.default.join(resourcesFolderPath, resourcePath));
}
function getDeviceProperties(device, password, username) {
    if (device === void 0) { device = undefined; }
    if (password === void 0) { password = undefined; }
    if (username === void 0) { username = undefined; }
    var env = process.env;
    var finalHost = device ? device : env.ROKU_DEVICE_ADDRESS;
    var finalUsername = username ? username : env.ROKU_DEVICE_USERNAME;
    var finalPassword = password ? password : env.ROKU_DEVICE_PASSWORD;
    if (finalHost && finalUsername && finalPassword) {
        return { host: finalHost, username: finalUsername, password: finalPassword };
    }
    else {
        throw Error("The following device properties should be set: device, password");
    }
}
function assertPathExists(projectPath) {
    if (!projectPath || !fs_1.default.existsSync(projectPath)) {
        throw Error("Path does not exist: ".concat(projectPath));
    }
}
