"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateKey = void 0;
var telnet_client_1 = __importDefault(require("telnet-client"));
var async_utils_1 = require("../utils/async-utils");
var DEFAULT_INTERVAL_BETWEEN_OPERATIONS = 5000;
function generateKey(deviceAddress) {
    return __awaiter(this, void 0, void 0, function () {
        var connection, params, response, password, dev_id, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    connection = new telnet_client_1.default();
                    params = {
                        host: deviceAddress,
                        port: 8080,
                        shellPrompt: '>',
                        timeout: 8000,
                        execTimeout: 8000
                    };
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 5, , 7]);
                    return [4 /*yield*/, connection.connect(params)];
                case 2:
                    _a.sent();
                    waitForDeviceToBeReady();
                    return [4 /*yield*/, connection.exec('genkey')];
                case 3:
                    response = _a.sent();
                    waitForDeviceToBeReady();
                    return [4 /*yield*/, connection.end()];
                case 4:
                    _a.sent();
                    password = extractVariable("Password", response);
                    dev_id = extractVariable("DevID", response);
                    if (password && dev_id) {
                        return [2 /*return*/, { dev_id: dev_id, password: password }];
                    }
                    else {
                        throw Error("Could not generate key: Failed to retrieve DevID/password from Roku device[".concat(deviceAddress, "]."));
                    }
                    return [3 /*break*/, 7];
                case 5:
                    error_1 = _a.sent();
                    return [4 /*yield*/, connection.destroy()];
                case 6:
                    _a.sent();
                    throw Error("Could not generate key: Failed to connect to Roku device[".concat(deviceAddress, "]."));
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.generateKey = generateKey;
function extractVariable(variableName, response) {
    var variableRegex = new RegExp("".concat(variableName, ": ([^\r\n]*)"));
    var matches = variableRegex.exec(response);
    if (matches) {
        var value = matches[1];
        return value;
    }
    return undefined;
}
// For now, we don't have a way to know when the device is ready for
// other operations, but it seems that giving some interval between actions
// improve the succcess rate of the implemented operations [AR]
function waitForDeviceToBeReady() {
    (0, async_utils_1.sleep)(DEFAULT_INTERVAL_BETWEEN_OPERATIONS);
}
