"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logError = exports.logSuccess = exports.logInfo = exports.logWarning = void 0;
var chalk_1 = __importDefault(require("chalk"));
var TOOL_PREFIX = '[roku-cli]';
var WARNING = { prefix: '[WARNING]', color: chalk_1.default.yellow };
var INFO = { prefix: '[INFO]', color: chalk_1.default.blue };
var SUCCESS = { prefix: '[SUCCESS]', color: chalk_1.default.green };
var ERROR = { prefix: '[ERROR]', color: chalk_1.default.red };
function logWarning(message) {
    prettyLog(WARNING, message);
}
exports.logWarning = logWarning;
function logInfo(message) {
    prettyLog(INFO, message);
}
exports.logInfo = logInfo;
function logSuccess(message) {
    prettyLog(SUCCESS, message);
}
exports.logSuccess = logSuccess;
function logError(message) {
    prettyLog(ERROR, message);
}
exports.logError = logError;
function prettyLog(style, message) {
    console.log(style.color("".concat(TOOL_PREFIX).concat(style.prefix).concat(message ? ": ".concat(message) : '')));
}
